<?php

use Slim\Http\Request;
use Slim\Http\Response;

// Routes

//$app->get('/[{name}]', function (Request $request, Response $response, array $args) {
$app->get('/', function (Request $request, Response $response, array $args) {
    // Sample log message
    $this->logger->info("GDDWorkshop '/' route");

    // Render index view
    return $this->renderer->render($response, 'index.html', $args);
});

$app->get('/registration', function (Request $request, Response $response, array $args) {
    // Sample log message
    $this->logger->info("GDDWorkshop '/registrtion' route");

    // Render index view
    return $this->renderer->render($response, 'registration.html', $args);
});


$app->get('/participants', function (Request $request, Response $response, array $args) {
    // Sample log message
    $this->logger->info("GDDWorkshop '/participants' route");
 	$db = new DB($this->db);
 	$data = $db->getAll();

    // Render index view
    return $this->renderer->render($response, 'participants.html', ['registros' => $data]);
});


$app->get('/committess', function (Request $request, Response $response, array $args) {
    // Sample log message
    $this->logger->info("GDDWorkshop '/committess' route");

    // Render index view
    //$this->flash->addMessage("lele","mensaje de lele");
    return $this->renderer->render($response, 'committess.html', $args);
});

/*
$mw = function ($request, $response, $next) {
    $response->getBody()->write('BEFORE');
    $response = $next($request, $response);
    $response->getBody()->write('AFTER');

    return $response;
};*/

// API ROUTES
$app->group('/api', function($app){

	$app->get("/test", function(Request $request, Response $response, array $args) {
		$this->logger->info("GDDWorkshop '/api/test' route");
		return var_dump($request);

	});

	$app->post('/register', function (Request $request, Response $response, array $args) {
	    // Sample log message
	    //$this->logger->debug(var_dump($request->getParsedBody()));
	    $db = new DB($this->db);
	    $data = $request->getParsedBody();
      $messages = $this->flash;
      if(!isset($data['nombre']))
        $messages->addMessageNow("submit-register-err", "First Name could not be empty");
      if(!isset($data['apellido']))
        $messages->addMessageNow("submit-register-err", "Last Name could not be empty");
      if(!isset($data['email']))
        $messages->addMessageNow("submit-register-err", "E-mail could not be empty");
      if(!isset($data['financiacion']))
        $messages->addMessageNow("submit-register-err", "Question about financial support must have a selected answer");
      if(!isset($data['invited']))
        $messages->addMessageNow("submit-register-err", "Question about 'invited to participate in this conference' must have a selected answer");
      if(!isset($data['letterinvited']))
        $messages->addMessageNow("submit-register-err", "Question about needing a letter of invitation must have a selected answer");
      if(!isset($data['g-recaptcha-response'])){
        $messages->addMessageNow("submit-register-err", "Please validate captcha!");
      }
      else {
        $recaptcha = new ReCaptcha\ReCaptcha($this->settings['recaptcha']['secret-test']);
        //get remote ip from request header TODO
        $resp = $recaptcha->verify($data['g-recaptcha-response'], $_SERVER['REMOTE_ADDR']);
        if(!$resp->isSuccess()){
          $messages->addMessageNow("submit-register-err", "ReCaptcha validation error " . implode($resp->getErrorCodes()));
        }
      }

      if($messages->hasMessage("submit-register-err")){

        $arrayresponse = array("success" => false, "errors"=>$messages->getMessage("submit-register-err"), "data"=>$data);
        $newres = $response->withJson($arrayresponse);
        return $newres;
      }
      else {

        /*try{
          $db->insert($data);
        }
        catch (Exception $e){
        $this->logger->debug($e->getMessage());
        return $e->getMessage();
      }*/
        echo "todo ok";
      }


	});

});
